<?php
// $Id: imageset.inc,v 1.1 2008/11/30 21:46:05 pvb Exp $

function theme_imageset($name, $index, $attributes = NULL) {
  
  $img = _imageset_imageset($name, TRUE);
  $output = '';
  if (isset($img) && !$img['dis']) {		
    $outname = _imageset_selector_outname();
    if ($attributes && is_array($attributes)) {
      if ($attributes['outname']) {
        $outname = $attributes['outname'];
        unset($attributes['outname']);
      }
    }
    $output = module_invoke_all('imageset_element', 'out-'.$outname, $name, $index, $attributes);
    if (is_array($output)) $output = reset($output);  
  }
  return $output;
}

function imageset_names() {
	
  $settings = variable_get('imageset', array());	
  foreach($settings as $name=>$value) {
    $result[$name] = $name;
  }
  return $result;
}

function _imageset_selector_outname($value = NULL) {

  return (isset($value) && $value['outname']? $value['outname']: 'default');
}

/*
$size - string "WxH"
return array ('sizex' => W, 'sizey' => H)
*/
function _imageset_explode_size($size) {

  $v = explode('x', $size);
  return array(
    'sizex' => intval($v[0]),
	'sizey' => intval($v[1]),
  );
}		

/*
return array
['imgname']	- path to imageset
['sizex'] 	- width map
['sizey'] 	- height map
['vh'] 	- orientation
*/
function _imageset_imageset($name, $check_css = FALSE) {
global $_imageset_imagesets;

  if (!isset($_imageset_imagesets)) {
    $_imageset_imagesets = array();
  }
  if (!isset($_imageset_imagesets[$name])) {
    $v = variable_get('imageset', array());
    $_imageset_imagesets[$name] = $v[$name];
  }
  $img = $_imageset_imagesets[$name];
  // include CSS
  if ($img && !$img['check_css'] && $check_css) {
    if (!$img['dis']) imageset_check_css($name);
    $_imageset_imagesets[$name]['check_css'] = TRUE;
  }
  return $img;
}

function _imageset_imagesets_uses() {
global $_imageset_imagesets;
	
  $result = array();
  $v = variable_get('imageset', array());
  foreach($v as $name => $img) {
    if(!$img['dis']) {
      if ($img['persistent'] || $_imageset_imagesets[$name]) {
        $result[$name] = $img;
      }
    }
  }
  return $result;
}

/*
NULL - delete
*/
function _imageset_imageset_update($name, $newvalue = NULL) {
global $_imageset_imagesets;

  $v = variable_get('imageset', array());
  $save_imgname = $v[$name]['imgname'];
  if (!isset($newvalue['name']) || (isset($newvalue['name']) && $name != $newvalue['name'])) {  // change name		
    unset($v[$name]);
  }
// reset cashe	
  unset($_imageset_imagesets[$name]);
	
  if (isset($newvalue['name'])) {
    $name = $newvalue['name'];
    unset($newvalue['name']);
  }
  if (isset($newvalue)) {
    $v[$name] = $newvalue;
  }
  ksort($v);
  variable_set('imageset', $v);
	
  if ($save_imgname && !isset($newvalue)) {
    if (dirname($save_imgname) == file_create_path('imagesets')) {
      file_delete($save_imgname);
    }
  }
}


function _imageset_selector_npp($npp) {

  $v = variable_get('imageset_style', array());
  return $v[intval($npp)-1];
}

function _imageset_selectors($name = NULL) {
	
  $v = variable_get('imageset_style', array());
  if ($name) {
    $result = array();
    foreach($v as $style) {
      if ($style['name'] == $name) {
        $result[] = $style;
      }
    }
    if (count($result) == 0) {	// default
      $result[] = array(
        'name' => $name,
        'select' => 1,
        'css' => '',
        'outname' => 'default',
      );
    }
    return $result;
  } 
  else return $v;
}

function _sort_imageset_selector($val1, $val2) {

  $result = strcasecmp($val1['name'], $val2['name']);
  if ($result == 0) {
    $result= ($val1['weight'] < $val2['weight'])? -1: (($val1['weight'] > $val2['weight'])? 1: 0);
  }
  if ($result == 0) {
    $result = strcasecmp($val1['css'], $val2['css']);
  }
  return $result;
}
/*
value - array(
	'name' - name imageset
	'select' - index for select 1...n
	'css' 		- CSS selector prefix
	'outname' 		- Outer name
	'weight'	- weight position in CSS
	)
if (value == NULL) DELETE
*/
function _imageset_selector_update($npp, $value = NULL) {

  if (!$npp && !isset($value))  return;
	
  $v = variable_get('imageset_style', array());
  if ($npp) {
    if (isset($value)) {
      $v[$npp - 1] = $value;
    }
    else unset($v[$npp - 1]);
  } 
  else $v[] = $value;
  usort($v, _sort_imageset_selector);
  variable_set('imageset_style', $v);
}

function _imageset_selector_delete($name) {

  $v = variable_get('imageset_style', array());
  foreach($v as $npp => $value) {
    if ($value['name'] == $name) {unset($v[$npp]);}
  }
  variable_set('imageset_style', $v);
}

function install_imageset($modulename, $filename_dat, &$buffer = NULL) {
  
  imageset_clear_css();
// first string - description
// name, filename, WxH, orientation,default outname; CSS selectors
  $file = fopen($filename_dat, 'r');
  if ($file) {
    $data = fgetcsv($file, 0, ';');
    $items = explode(',', $data[0]);
    $name = $items[0];
    $imgname = $items[1];
    if (dirname($imgname) == '' || dirname($imgname) == '.') {
      $dir = dirname($filename_dat);
      if ($dir == '') $dir = getcwd ();
      $imgname = $dir.'/'.$imgname;
    }
    $value = array_merge(
      array(
        'imgname' => $imgname,
        'vh' => intval($items[3]),
        'module' => $modulename,
      ),
      _imageset_explode_size($items[2])
    );
    $replace_index = 0;
    while (_imageset_imageset($name)) {
      if(!$replace_index) {
        if (preg_match("/_(\d)+$/", $name, $matches)) {
          $replace_index = $matches[1];
        } 
        else $name .= '_0';
      }
      $replace_index++;
      $name = preg_replace("/_(\d)+$/", '_'.$replace_index, $name);
    }
    _imageset_imageset_update($name, $value);
    $outname = $items[4];
    $select = 1;
    while ($select< count($data)) {
      $value = array(
        'name' => $name,
        'select' => $select,
        'css' => $data[$select],
        'outname' => $outname,
        'weight' => $select - 1,
      );
      _imageset_selector_update(0, $value);
      $select++;
    }
    if (func_num_args()>2) { 
      $buffer = array();
      while ($buffer[] = fgets($file)) { }
    }
    fclose($file);
  }
  return $name;
}

function uninstall_imageset($modulename) {
  imageset_clear_css();
  $v = variable_get('imageset', array());
  foreach($v as $name => $img) {
    if ($img['module'] == $modulename) {
      _imageset_imageset_update($name);
      _imageset_selector_delete($name);
    }
  }
}
